package com.eactive.eai.common.util.convert;

import java.util.Stack;

import org.nfunk.jep.ParseException;
import org.nfunk.jep.function.PostfixMathCommand;


/**
 * ASCII 값을 EBCDIC으로 변환하는 함수.
 * 입력 값은 byte[], 결과는 byte[]임.
 */
public class ASCII2EBCDIC9 extends PostfixMathCommand {
    public ASCII2EBCDIC9() {
        numberOfParameters = 2;
    }

    @SuppressWarnings({ "rawtypes", "unchecked" })
	public void run(Stack inStack) throws ParseException {
        checkStack(inStack);

        Object param2 = inStack.pop();
        int len = ((Number) param2).intValue();


        Object param = inStack.pop();

        byte[] value = null;

        if (param instanceof String) {
            value = ((String) param).getBytes();
        } else if (param instanceof byte[]) {
            value = (byte[]) param;
        } else if (param == null) {
            inStack.push(null);
        } else {
            throw new ParseException(
                "Function의 파라미터 인수가 byte[], String이 아닙니다. : " + param);
        }



        try {
            //byte[] buff = CodeConversion.ascToSE9(value, len);
            byte[] buff = (value == null) ? new byte[0] : CodeConversion.ascToSE9(value, len); // 20250910 npe
            inStack.push(buff);
        } catch (Exception e) {
            throw new ParseException(e.getMessage());
        }
    }
}
